<?php

namespace FiloBlu\ExtTargetRule\Block\Catalog\Product\ProductList;

use FiloBlu\ExtTargetRule\Helper\Data;

//class Upsell extends \Magento\TargetRule\Block\Catalog\Product\ProductList\Upsell
class Upsell extends \Magento\Catalog\Block\Product\ProductList\Upsell
{
    /**
     * @var \Magento\Catalog\Block\Product\Context
     */
    protected $context;

    /**
     * @param \Magento\Catalog\Block\Product\Context $context
     * @param \Magento\Checkout\Model\ResourceModel\Cart $checkoutCart
     * @param \Magento\Catalog\Model\Product\Visibility $catalogProductVisibility
     * @param \Magento\Checkout\Model\Session $checkoutSession
     * @param \Magento\Framework\Module\Manager $moduleManager
     * @param array $data
     */
    public function __construct(
        \Magento\Catalog\Block\Product\Context $context ,
        \Magento\Checkout\Model\ResourceModel\Cart $checkoutCart ,
        \Magento\Catalog\Model\Product\Visibility $catalogProductVisibility ,
        \Magento\Checkout\Model\Session $checkoutSession ,
        \Magento\Framework\Module\Manager $moduleManager ,
        array $data = []
    )
    {
        parent::__construct($context , $checkoutCart , $catalogProductVisibility , $checkoutSession , $moduleManager , $data);
        $this->_storeManager = $context->getStoreManager();
    }

    /**
     * @return string
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function getUpsellAjaxUrl()
    {
        //get site base url
        /** @var \Magento\Store\Model\StoreManagerInterface $baseUrl */
        $baseUrl = $this->_storeManager->getStore()->getBaseUrl();

        //get current product
        /** @var \Magento\Catalog\Model\Product $product */
        $product = $this->getProduct();

        return $baseUrl . "exttargetrule/products/upsell/id/" . $product->getEntityId();
    }

    /**
     * @return null
     */
    public function getCacheLifetime()
    {
        return null;
    }
}